<?php
// Bilderstapel 1.0
// zeigt einen Bilderstapel an. Reines php/GD2-Lib. 
// (also als ob jemand einen Stapel Fotos unachtsam auf den Tisch geworfen hat)
// Vorsicht: Reinweiss (255,255,255) in Hintergrund und Bildern wird zwischendurch transparent gesetzt
// (c) 2008 Jrgen Galupki, http://galupki.de


// maximale Breite/Hhe der Bilder in Pixeln. Empfohlen: 240! 
// Kleinere bleiben im Original; Grere werden skaliert!
 $bildgroessemax = 120;                                   // was nicht passt, wird passend gemacht...
 $versatzmin = 10;                                        // zufaellige Ablage oben links zwischen min/max
 $versatzmax = 40;

// Pfad zu einem Hintergrundbild (True Color, JPEG) oder Farbwerte RGB fr eine Hintergrundfarbe
// empfohlene Gre passend zu allen anderen Werten: 500x500
 $desktop = "../foto/wood_240x240.jpg";  // oder leer und folgende Parameter:
 $desktopgroesse = 240;
 $drgb_r  = 245;
 $drgb_g  = 245;
 $drgb_b  = 245;

// Breite des Rahmens (weiss 254,254,254) um die Fotos
 $rahmen  = 12;                                           // Rahmenstaerke oder 0

// Liste der darzustellenden Bilder (True Color, JPEG)
// empfohlene Gre ca. 240 Pixel breit, Anzahl ca. 5
 $paths   = array(                                        // Liste der darzustellenden Bilder (jpg)
 
            "http://galupki.de/galerie/index.php?vorschau=1&dia=./Galerie/",
            "http://galupki.de/galerie/index.php?vorschau=1&dia=./Galerie/",
            "http://galupki.de/galerie/index.php?vorschau=1&dia=./Galerie/",
            "http://galupki.de/galerie/index.php?vorschau=1&dia=./Galerie/",
            "http://galupki.de/galerie/index.php?vorschau=1&dia=./Galerie/"
            );


if ( isset($_REQUEST["size"]) ) {
   $desktop        = "../foto/wood_500x500.jpg";
   $bildgroessemax = 240;
   $versatzmax     = 150;
}
            

bilderstapel($paths);   // <--------------- so gehts dann!


// ----------------------------------------------------------------------------------------------------------------
          

function bilderstapel($paths) {
// zeigt den Bilderstapel auf dem Hintergrund an. Bildnamen im Array bergeben

 global $desktop, $drgb_r, $drgb_g, $drgb_b, $rahmen, $desktopgroesse, $versatzmin, $versatzmax;
 

// Hintergrund  

      if ( file_exists($desktop) ) { // Hintergrundbild
         $canvas = imagecreatefromjpeg($desktop); 
      }  else { // nur Hintergrundfarbe
         $canvas = imagecreatetruecolor($desktopgroesse, $desktopgroesse); 
         $farbe = imageColorAllocate ($canvas, $drgb_r, $drgb_g, $drgb_b);
         imagefill ( $canvas, 0, 0,  $farbe);
      }

// weiss Transparent setzen im Hintergrundbild

      $weissc = imageColorAllocate ($canvas, 255, 255, 255);
      imagecolortransparent($canvas, $weissc);
       
              
// fuer alle bermittelten Vordergrundbilder

      foreach ( $paths as $image ) {

//      Bild mit oder ohne Rahmen                 
        if ( $rahmen>0 ) {  
           $srcjpg  = @imagecreatefromjpeg ($image);
           if ( $srcjpg=="" ) continue; // hart raus fuer dies Bild
           bildgroesse_anpassen($srcjpg);
           $sizes[0] = imagesx($srcjpg);
           $sizes[1] = imagesy($srcjpg);
           $tmpjpg  = imagecreatetruecolor($sizes[0]+2*$rahmen, $sizes[1]+2*$rahmen);
           $rahmenfarbe = imageColorAllocate ($tmpjpg, 254, 254, 254);
           imagefill ( $tmpjpg, 0, 0,  $rahmenfarbe);
           $dummy = imagecopyresampled ( $tmpjpg, $srcjpg, $rahmen, $rahmen, 0, 0, 
                                         imagesx($srcjpg), imagesy($srcjpg),  imagesx($srcjpg), imagesy($srcjpg) ); 
           imagedestroy($srcjpg);
        }  else { // Bild ohne Rahmen 
           $tmpjpg = @imagecreatefromjpeg ($image);  
           if ( $tmpjpg=="" ) continue; // hart raus fuer dies Bild
           bildgroesse_anpassen($tmpjpg);
        }

//      reinweiss Transparent setzen im Bild
        $weissj = imageColorAllocate ($tmpjpg, 255, 255, 255);
        imagecolortransparent($tmpjpg, $weissj);

//      bis zu 45 Grad drehen nach links oder rechts
        $angle = mt_rand( 1, 45 );
        if ( mt_rand( 1, 2 ) % 2 === 0 ) { // links- oder rechtsdrehend...
           $angle *= -1;
        }
        $rotate = imagerotate($tmpjpg, $angle, -1);

//      kopiere das aktuelle Bild auf den Hintergrund          
        $dummy = imagecopyresampled ( $canvas, $rotate, 
                                      mt_rand( $versatzmin, $versatzmax ), mt_rand( $versatzmin, $versatzmax ), 
                                      0, 0, 
                                      imagesx($rotate), imagesy($rotate),  imagesx($rotate), imagesy($rotate) );

//      Resourcen freigeben         
        imagedestroy($tmpjpg);
        imagedestroy($rotate);

      } // end foreach Bild


// Bild ausgeben als png
      header( "Content-Type: image/png" );
      echo imagepng($canvas);
      imagedestroy($canvas);


}  // end function bilderstapel


/* --- Hilfsroutinen ----------------------------------------------------------------------------------------- */


function bildgroesse_anpassen(&$neujpg) {
// --- verkleinert das letzte geladene $neujpg (GD2-BildResource) passend falls notwendig ----------


global $bildgroessemax;


// vereinbarte Gre 
  $vbg = $bildgroessemax;

// Originalbild
   $jpg_breite = imagesx ($neujpg);
   $jpg_hoehe  = imagesy ($neujpg);

// etwas zu tun?
   if ( max($jpg_breite,$jpg_hoehe)<=$vbg ) {
      return ; // nein
   }


// Hochformat statt Querformat
   if ($jpg_hoehe > $jpg_breite ) {
      $vbg = $jpg_breite * $vbg / $jpg_hoehe;
   }

// Vorschaubild
   if ( $jpg_breite > $vbg ) {
      $x = $vbg;
      $y = $jpg_hoehe * $vbg / $jpg_breite;
   }  else {
      $x = $jpg_breite;
      $y = $jpg_hoehe;
   }
   $kleinesjpg = imagecreatetruecolor ( $x, $y);
   $dummy = imagecopyresampled ( $kleinesjpg, $neujpg, 0, 0, 0, 0, $vbg, $y, $jpg_breite, $jpg_hoehe);  

   $neujpg = imagecreatetruecolor ( $x, $y);
   $dummy = imagecopyresampled ( $neujpg, $kleinesjpg, 0, 0, 0, 0, $x, $y, $x, $y);  
   imagedestroy($kleinesjpg);
   

} // end function bildgroesse_anpassen





  
?>
